<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2009 Kurt Gusbeth <gusbeth@aol.com>
*  All rights reserved
*
*  This script is part of the TYPO3 project. The TYPO3 project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*
*  This script is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

require_once(PATH_tslib.'class.tslib_pibase.php');


/**
 * Plugin 'My quiz and poll' for the 'myquizpoll' extension.
 *
 * @author	Kurt Gusbeth <gusbeth@aol.com>
 * @package	TYPO3
 * @subpackage	tx_myquizpoll
 */
class tx_myquizpoll_pi1 extends tslib_pibase {
	var $prefixId      = 'tx_myquizpoll_pi1';				// Same as class name
	var $scriptRelPath = 'pi1/class.tx_myquizpoll_pi1.php';	// Path to this script relative to the extension directory
	var $extKey        = 'myquizpoll';						// The extension key.
	var $conf = array();
	var $answerChoiceMax = 5;								// This max cannot be changed without changing the TCA (and DB)!
	var $lang = 0;											// language
	var $templateCode = '';
	var $origTemplateCode = '';
	
	/**
	 * Main method of your PlugIn
	 *
	 * @param	string		$content: The content of the PlugIn
	 * @param	array		$conf: The PlugIn Configuration
	 * @return	The content that should be displayed on the website
	 */
	function main($content,$conf)	{
		$this->conf=$conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->pi_USER_INT_obj=1;	// Configuring so caching is not expected. This value means that no cHash params are ever set. We do this, because it's a USER_INT object!
		$thePID = 0;				// Default values
		$uid = 0;
		$elapseTime = 0;   // intval($this->conf['quizTimeMinutes'])*60;			// Verflossene Zeit in Sekunden
		$questionPage = false;
		$answerPage = false;
		$finalPage = false;
		
		// global $TSFE;
		$this->lang = $GLOBALS['TSFE']->config['config']['sys_language_uid']; 
		//$this->lang = $_GET['L'];
		//if ($this->lang == '') $this->lang = $_POST['L'];
		if ($this->lang == '') $this->lang = 0;		// falls keine Sprache gesetzt wurde
		
		if (t3lib_extMgm::isLoaded('sr_freecap') ) {		// load Captcha: Anti-Spam-Tool ???
			require_once(t3lib_extMgm::extPath('sr_freecap').'pi2/class.tx_srfreecap_pi2.php');
			$this->freeCap = t3lib_div::makeInstance('tx_srfreecap_pi2');
		}
		
		if( !($this->cObj->data['pages'] == '') ) {		// PID
			$thePID = $this->cObj->data['pages'];
		} elseif( !($this->conf['PID'] == '') )  { 
			$thePID = $this->conf['PID']; 
		} else { 
			$thePID = $GLOBALS["TSFE"]->id;
		}
		
		if ($this->conf['answerChoiceMax'])					// antworten pro fragen
			$this->answerChoiceMax = intval($this->conf['answerChoiceMax']);
		
		mt_srand(hexdec(substr(md5(microtime()), -8)) & 0x7fffffff);  // Seed random number generator
		$this->local_cObj = t3lib_div::makeInstance("tslib_cObj");	// Local cObj
		$quiz_taker_ip_address = t3lib_div::getIndpEnv("REMOTE_ADDR");	// Collect ip address of quiz taker
		
		// Get post parameters: Submited Quiz-data
		$quizData = array();
		if (is_array(t3lib_div::GPvar($this->prefixId))) {
		  $quizData = t3lib_div::slashArray(t3lib_div::GPvar($this->prefixId),"strip");
		  if ($quizData["cmd"]=='')
		    $quizData["cmd"] = $conf['CMD'];
		} else {
		  $quizData["cmd"] = $conf['CMD'];		// get the CMD from the backend
		}
		
		// Load template
		$this->initTemplate();
		
		// Marker values		
		$markerArray=array();
		$subpartArray=array();
		$wrappedSubpartArray=array();
		$markerArrayP=array();
		$markerArrayP["###REF_HIGHSCORE###"] = '';
		$markerArrayP["###REF_HIGHSCORE_URL###"] = '';
		$markerArrayP["###REF_POLLRESULT_URL###"] = '';		
		$markerArrayP["###REF_QUIZ_ANALYSIS###"] = '';
		$markerArrayP["###REF_NO_MORE###"] = '';
		$markerArrayP["###REF_ERRORS###"] = '';
		$markerArrayP["###REF_RES_ERRORS###"] = '';
		$markerArrayP["###REF_QUESTIONS###"] = '';
		$markerArrayP["###REF_QRESULT###"] = '';
		$markerArrayP["###REF_INTRODUCTION###"] = '';
		$markerArrayP["###REF_QPOINTS###"] = '';
		$markerArrayP["###REF_NEXT###"] = '';
		$markerArrayP["###REF_POLLRESULT###"] = '';
		$markerArrayP["###PREFIX###"] = $this->prefixId;
		$markerArrayP["###FORM_URL###"] = $this->pi_getPageLink($GLOBALS['TSFE']->id);
		$markerArray["###PREFIX###"] = $this->prefixId;
		$markerArray["###FORM_URL###"] = $this->pi_getPageLink($GLOBALS['TSFE']->id);
		$markerArray["###NAME###"] = $this->pi_getLL('name','name');
		$markerArray["###EMAIL###"] = $this->pi_getLL('email','email');
		$markerArray["###HOMEPAGE###"] = $this->pi_getLL('homepage','homepage');
		$markerArray["###GO_ON###"] = $this->pi_getLL('go_on','go_on');
		$markerArray["###SUBMIT###"] = $this->pi_getLL('submit','submit');
		$markerArray["###RESET###"] = $this->pi_getLL('reset','reset');
		$markerArray["###CORRECT_ANSWERS###"] = $this->pi_getLL('correct_answers','correct_answers');
		$markerArray["###EXPLANATION###"] = $this->pi_getLL('listFieldHeader_explanation', 'listFieldHeader_explanation');
		if ($this->conf['pageTimeSeconds'] || $this->conf['quizTimeMinutes']) {
			$markerArray["###TIME_UP1###"] = $this->pi_getLL('time_up1','time_up1');
			$markerArray["###LIMIT1A###"] = $this->pi_getLL('limit1a','limit1a');
			$markerArray["###LIMIT1B###"] = $this->pi_getLL('limit1b','limit1b');
			$markerArray["###TIME_UP2###"] = $this->pi_getLL('time_up2','time_up2');
			$markerArray["###LIMIT2A###"] = $this->pi_getLL('limit2a','limit2a');
			$markerArray["###LIMIT2B###"] = $this->pi_getLL('limit2b','limit2b');
			$markerArray["###SECONDS###"] = $this->pi_getLL('seconds','seconds');
			$markerArray["###MINUTES###"] = $this->pi_getLL('minutes','minutes');
		}
		
		// Link to the Highscore list
  		$urlParameters = array("tx_myquizpoll_pi1[cmd]" => "score", "tx_myquizpoll_pi1[qtuid]" => $quizData["qtuid"], "no_cache" => "1");
		$markerArray["###HIGHSCORE_URL###"] = $this->pi_linkToPage($this->pi_getLL('highscore_url','highscore_url'), $GLOBALS['TSFE']->id, $target = '', $urlParameters);
		
		// Init
		$no_rights = 0;			// second entry of the quiz taker or not logged in if requiered?
		$leftQuestions = 0;		// no. of questions to be shown
		$whereAnswered = '';	// questions that have been allready answered (UIDs)
		$content = '';			// content to be shown
		$tableQuestions = 'tx_myquizpoll_question';
		$tableAnswers   = 'tx_myquizpoll_result';

		// check, if logged in
		if ( $this->conf['loggedInCheck'] && $quizData["cmd"]!='score' && !$GLOBALS['TSFE']->loginUser ) {
			$no_rights = 1;					// noname user is (b)locked now
			$markerArray["###NOT_LOGGEDIN###"] = $this->pi_getLL('not_loggedin','not_loggedin');
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_NOT_LOGGEDIN###");
			$content .= $this->cObj->substituteMarkerArray($template, $markerArray);  	// Sonderfall !!!
		}

		// check for second entry ( based on the ip-address )
		if ( $this->conf['doubleEntryCheck'] && $quizData["cmd"]!='score' && !$quizData["qtuid"] && $no_rights == 0 ) {
			$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery( 'tstamp',
															$tableAnswers,
															'pid='.$thePID." AND ip='".$quiz_taker_ip_address."' AND sys_language_uid=".
																$this->lang.' '.$this->cObj->enableFields($tableAnswers),
															'',
															'tstamp DESC',
															'1');
			$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
			if ($rows>0) {							// DB entry found for current user?
				$fetchedRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5);
				$dateOld = $fetchedRow['tstamp'];
				$period = intval($this->conf['doubleEntryCheck']);	// seconds
				if ($period < 10000) $period *= 60*60*24;		// days
				//if ($period==1) $period = 50000;		// approx. a half day is the quiz blocked for the same ip-address
				if ((time() - $dateOld) < $period) {  
					$no_rights = 1;						// user is (b)locked now
					$markerArray["###DOUBLE_ENTRY###"] = $this->pi_getLL('double_entry','double_entry');
					$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_DOUBLE_ENTRY###");
					$content .= $this->cObj->substituteMarkerArray($template, $markerArray);		 // Sonderfall !!!
				}
			}
		}
		
		// check if the captcha is OK
		if ($quizData["cmd"]  == 'submit' && is_object($this->freeCap) && $this->conf['enableCaptcha'] && !$this->freeCap->checkWord($quizData['captcha_response']) && $no_rights == 0) {
			$quizData["cmd"]  = 'next';		// "nochmal" simulieren
			//$quizData["qtuid"] = '';		// wieso wohl???
			$markerArray["###CAPTCHA_NOT_OK###"] = $this->pi_getLL('captcha_not_ok','captcha_not_ok');
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_CAPTCHA_NOT_OK###");
			$markerArrayP["###REF_ERRORS###"] .= $this->cObj->substituteMarkerArray($template, $markerArray);	// instead of $content 
		}

		// read quiz takers old data
		$answeredQuestions = 0;     // prev. answered Question(s)
		if ((($this->conf['useCookiesInDays']>0 && !$quizData["qtuid"]) || 
			 ($quizData["cmd"]  == 'next') ||
			 ($quizData["cmd"]  == 'submit' && !$this->conf['isPoll'] && (!$this->conf['dontShowPoints'] || $this->conf['quizTimeMinutes']))) && $no_rights == 0 ) {
			 
			if (!$quizData["qtuid"] && !($quizData["cmd"]  == 'next' || $quizData["cmd"]  == 'submit'))
				$quizData["qtuid"] = $_COOKIE["myquizpoll".$thePID];	// read quiz taker UID and from a cookie
			// oder? $HTTP_COOKIE_VARS["myquizpoll".$thePID];    oder?  $GLOBALS["TSFE"]->fe_user->getKey("ses","myquizpoll".$thePID); 
			
			if ($quizData["qtuid"]) {	// load solved questions and quiz takers name, email, homepage, old points and last time
				$uid = intval($quizData["qtuid"]);
				$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('name, email, homepage, qids, p_or_a, p_max, percent, o_max, o_percent, firsttime',
					$tableAnswers,
					'uid='.$uid.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableAnswers),
					'',
					'',
					'');
				$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
				if ($rows>0) {							// DB entry found for current user?
					$fetchedRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5);
					$answeredQuestions = $fetchedRow['qids'];
					if ($answeredQuestions && !$this->conf["isPoll"]) {
						if ($quizData["cmd"]  != 'submit') {			// namen nicht berschreiben
							$whereAnswered = ' AND uid NOT IN ('.$answeredQuestions.')';	// exclude answered questions next time
							$quizData["name"] = $fetchedRow['name'];
							$quizData["email"] = $fetchedRow['email'];
							$quizData["homepage"] = $fetchedRow['homepage'];
						}
						$markerArray["###VAR_TOTAL_POINTS###"] = intval($fetchedRow['p_or_a']);		// save total points for the case there are no more questions
						$markerArray["###VAR_TMAX_POINTS###"] = intval($fetchedRow['p_max']);
						$markerArray["###VAR_TMISSING_POINTS###"] = intval($fetchedRow['p_max']) - intval($fetchedRow['p_or_a']);
						$markerArray["###VAR_PERCENT###"] = intval($fetchedRow['percent']);
						$markerArray["###VAR_OMAX_POINTS###"] = intval($fetchedRow['o_max']);
						$markerArray["###VAR_OVERALL_PERCENT###"] = intval($fetchedRow['o_percent']);
						$elapseTime = time() - intval($fetchedRow['firsttime']);
					}
				}
			} else if ($this->conf['quizTimeMinutes'] && $quizData["time"]) {
				$elapseTime = time() - intval($quizData["time"]);		// before saving data
			}
		}
		
		// check, if quiz is cancled
		if ( $this->conf['quizTimeMinutes'] && ((intval($this->conf['quizTimeMinutes'])*60 - $elapseTime)<=0) ) {     // oder $quizData['cancel'] == 1 ) {
			$no_rights = 1;					// cancel all
			$markerArray["###QUIZ_END###"] = $this->pi_getLL('quiz_end','quiz_end');
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_END###");
			$content .= $this->cObj->substituteMarkerArray($template, $markerArray);		// sonderfall !!!
		}

		// next page is a page with questions...
		if ($quizData["cmd"] == 'next')
			$quizData["cmd"] = '';
		
		
		if( $quizData["cmd"] == 'submit' && $no_rights == 0 ) {   /* ***************************************************** */
			/*
			 * Display result page: answers and points
			 */

			// Check quiz taker name and email
			if ( trim($quizData["name"]) == "" ) {
				$quizData["name"] = $this->pi_getLL('no_name','no_name');
			}
			if ( !(t3lib_div::validEmail(trim($quizData["email"]))) ) {
				$quizData["email"] = $this->pi_getLL('no_email','no_email');
			}

			// Avoid bad characters in database request
			$quiz_taker_name = $GLOBALS['TYPO3_DB']->quoteStr($quizData["name"], $tableAnswers); //addslashes($quizData["name"]);
			$quiz_taker_email  = $GLOBALS['TYPO3_DB']->quoteStr($quizData["email"], $tableAnswers); //addslashes($quizData["email"]);
			$quiz_taker_homepage = $GLOBALS['TYPO3_DB']->quoteStr($quizData["homepage"], $tableAnswers); //addslashes($quizData["homepage"]);
			
			$markerArray["###REAL_NAME###"] = $quiz_taker_name;
			$markerArray["###REAL_EMAIL###"] = $quiz_taker_email;
			$markerArray["###REAL_HOMEPAGE###"] = $quiz_taker_homepage;
			$markerArray["###RESULT_FOR###"] = $this->pi_getLL('result_for','result_for');
			$markerArray["###THANK_YOU###"] = $this->pi_getLL('thank_you','thank_you');
			$markerArray["###RES_QUESTION_POINTS###"] = $this->pi_getLL('result_question_points','result_question_points');
			if ( !$this->conf['dontShowPoints'] && !$this->conf['isPoll'] ) {
				$markerArray["###P1###"] = $this->pi_getLL('p1','p1');
				$markerArray["###P2###"] = $this->pi_getLL('p2','p2');
			} else {
				$markerArray["###P1###"] = '';
				$markerArray["###P2###"] = '';
			}
				
			if ( $quiz_taker_email==$this->pi_getLL('no_email','no_email') ) {
				$quiz_taker_email='';
			}
			if ( $quiz_taker_homepage==$this->pi_getLL('no_homepage','no_homepage') ) {
				$quiz_taker_homepage='';
			}
			
			
			// Begin HTML output
			if ( $this->conf['isPoll'] ) {
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_POLL_SUBMITED###");	// Output thank you
				$markerArrayP["###REF_INTRODUCTION###"] = $this->cObj->substituteMarkerArray($template, $markerArray);  // instead $content
			} else if ( !$this->conf['dontShowUserData'] && !$this->conf['dontShowUserResult'] ) {	
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_USER_SUBMITED###"); // Output the user name
				$markerArrayP["###REF_INTRODUCTION###"] = $this->cObj->substituteMarkerArray($template, $markerArray);	// instead $content
			}		
			
			$template_qr = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QRESULT###"); // full template
			$template_answer = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_CORR###");
			$template_okok = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_CORR_ANSW###");
			$template_oknot = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_CORR_NOTANSW###");
			$template_notok = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_NOTCORR_ANSW###");
			$template_notnot = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_NOTCORR_NOTANSW###");
			$template_qr_points = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_POINTS###");
			$template_expl = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_EXPLANATION###");
			$template_delimiter = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_DELIMITER###");
			
			// Get questions from the database
			$questionsArray = array();
			$questionNumber = 0;
			$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*',
					$tableQuestions,
					'pid='.$thePID.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableQuestions),
					'',
					'',
					'');
			$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
			if ($rows>0) {
				while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5)){ 
					$questionNumber = $row['uid'];			// save the uid for each question
					$questionsArray[$questionNumber] = $row; 	// save each question
				}
			}
			$GLOBALS['TYPO3_DB']->sql_free_result($res5); 
			
			// Get the answers from the user
			$answerArray = array();
			$questionNumber = 1;
			while( $quizData['uid'.$questionNumber] ) {
				$answerArray[$questionNumber] = $quizData['uid'.$questionNumber];
				$questionNumber++;
			}
			$maxQuestions = $questionNumber-1;

			$points=0;				// points from the user (quiz taker)
			$maxPoints=0;			// maximum points reachable per page
			$maxTotal=0;			// maximum total points reachable
			$percent=0;				// 100 * reached points / total points
			$overallMaximum = 0;	// overall points of all questions
			$overallPercent = 0;	// overall percent
			$questionUID=0;			// uid of a question
			$answered='';			// uids of answered questions
			
			// Old questions and answers
			for( $questionNumber=1; $questionNumber < $maxQuestions+1; $questionNumber++ ) {
				$questionUID = $answerArray[$questionNumber]; 
				$row = $questionsArray[$questionUID];
				$answered.=",".$questionUID;
				$questionPoints=0;
				$maxQuestionPoints=0;
				
				if ($this->conf['isPoll']) {	// link to the result page    && $this->conf['showPollResultLink']
					$urlParameters = array("tx_myquizpoll_pi1[cmd]" => "list", "tx_myquizpoll_pi1[qid]" => $questionUID, "no_cache" => "1");
					$markerArray["###POLLRESULT_URL###"] = $this->pi_linkToPage($this->pi_getLL('poll_url','poll_url'), $GLOBALS['TSFE']->id, $target = '', $urlParameters);
				}

				// Output the result/explanations
				if ( !($this->conf['dontShowCorrectAnswers'] && $this->conf['dontShowPoints']) || $this->conf['isPoll'] ) {
				
					$markerArray["###VAR_QUESTION_TITLE###"] = $row['title'];
					$markerArray["###VAR_QUESTION_NAME###"] = $row['name'];
					$markerArray["###REF_QR_ANSWER_CORR###"] = '';
					$markerArray["###REF_QR_ANSWER_CORR_ANSW###"] = '';
					$markerArray["###REF_QR_ANSWER_CORR_NOTANSW###"] = '';
					$markerArray["###REF_QR_ANSWER_NOTCORR_ANSW###"] = '';
					$markerArray["###REF_QR_ANSWER_NOTCORR_NOTANSW###"] = '';
					$markerArray["###REF_QR_POINTS###"] = '';
					$markerArray["###VAR_QUESTION_ANSWER###"] = '';
					$markerArray["###VAR_ANSWER_POINTS###"] = '';
					$markerArray["###VAR_QUESTION_POINTS###"] = '';
					$markerArray["###VAR_MAX_QUESTION_POINTS###"] = '';
					$markerArray["###REF_QR_EXPLANATION###"] = '';
					$markerArray["###REF_DELIMITER###"] = '';
					if ( $this->conf['dontShowPoints'] )
						$markerArray["###NO_POINTS###"] = '';
					else
						$markerArray["###NO_POINTS###"] = '0';
					
					if (is_array($this->conf['myVars.']['questions.'])) {
						foreach($this->conf['myVars.']['questions.'] as $key => $value) {
							$myQArray = split(',', $value);
							$myKey = ($questionNumber-1)%count($myQArray);
							$markerArray["###MY_".strtoupper($key)."###"] = $myQArray[$myKey];
						}
					}
					
					for( $answerNumber=1; $answerNumber < $this->answerChoiceMax+1; $answerNumber++ ) {
						
						if ($row['answer'.$answerNumber]) {	// was a answer set in the backend?
							
							$selected=0;	// was the answer selected by the quiz taker?
							if (is_array($this->conf['myVars.']['answers.'])) {
								foreach($this->conf['myVars.']['answers.'] as $key => $value) {
									$myAArray = split(',', $value);
									$myKey = ($answerNumber-1)%count($myAArray);
									$markerArray["###MY_".strtoupper($key)."###"] = $myAArray[$myKey];
								}
							}
							
							if ( !$this->conf['isPoll'] ) {	// show correct answers. Bug fixed: dontShowCorrectAnswers doesnt matter here
								if ($row['correct'.$answerNumber] || $row['qtype']==3) {
									$maxPoints=$maxPoints+$row['points'];
									$maxQuestionPoints=$maxQuestionPoints+$row['points'];
								}
								if ( !$this->conf['dontShowCorrectAnswers'] )
									$markerArray["###VAR_QUESTION_ANSWER###"] = $row['answer'.$answerNumber];
								if ( !$this->conf['dontShowPoints'] )
									$markerArray["###VAR_ANSWER_POINTS###"] = $row['points'];

								if ($quizData['answer'.$questionNumber.'_'.$answerNumber]!='') {	// type 0
									$selected=$answerNumber; 
								} else if ($row['qtype']>0 && $row['qtype']<3 && $quizData['answer'.$questionNumber]==$answerNumber) {
									$selected=$answerNumber;
								} else if ($row['qtype']==3 && $quizData['answer'.$questionNumber]!='') {	// type 3
									$selected=$answerNumber;
								}
							}
							
							if ($this->conf['isPoll']) { 
								$points=$quizData['answer'.$questionNumber];						// points = SELECTED ANSWER !!!
							} else if ($selected>0 && ( ($row['qtype']==3 && strtolower($row['answer'.$answerNumber])==strtolower($quizData['answer'.$questionNumber])) ||
														($row['qtype']< 3 && $row['correct'.$answerNumber]) )) {
								$questionPoints=$questionPoints+$row['points'];
								if ( !$this->conf['dontShowCorrectAnswers'] )
									$markerArray["###REF_QR_ANSWER_CORR_ANSW###"] .= $this->cObj->substituteMarkerArray($template_okok, $markerArray);
							} else if ($selected>0) {
								if ($this->conf['noNegativePoints']!=2)
									$questionPoints=$questionPoints-$row['points'];
								if ( !$this->conf['dontShowCorrectAnswers'] )
									if ($row['qtype']==3) {		// since 0.1.8: falsche antwort und richtige antwort ausgeben
										$markerArray["###REF_QR_ANSWER_CORR_NOTANSW###"] .= $this->cObj->substituteMarkerArray($template_oknot, $markerArray);
										$markerArray["###VAR_QUESTION_ANSWER###"] = $quizData['answer'.$questionNumber];
									}
									$markerArray["###REF_QR_ANSWER_NOTCORR_ANSW###"] .= $this->cObj->substituteMarkerArray($template_notok, $markerArray);
							} else if ($row['correct'.$answerNumber] && !$this->conf['dontShowCorrectAnswers']) {
								$markerArray["###REF_QR_ANSWER_CORR_NOTANSW###"] .= $this->cObj->substituteMarkerArray($template_oknot, $markerArray);
							} else if ( !$this->conf['dontShowCorrectAnswers'] ) {
								$markerArray["###REF_QR_ANSWER_NOTCORR_NOTANSW###"] .= $this->cObj->substituteMarkerArray($template_notnot, $markerArray);
							}
							if (!$this->conf['isPoll'] && ($row['correct'.$answerNumber] || $row['qtype']==3) && !$this->conf['dontShowCorrectAnswers']) { // all correct answers
								$markerArray["###REF_QR_ANSWER_CORR###"] .= $this->cObj->substituteMarkerArray($template_answer, $markerArray);
							}
							
						}
					}
					
					if (!$this->conf['dontShowPoints'] && !$this->conf['isPoll']) {		// Bug fixed: dontShowCorrectAnswers doesnt matter here
						if ($questionPoints<0 && $this->conf['noNegativePoints']) $questionPoints=0;
						$points=$points+$questionPoints;
					}
					
					if (!$this->conf['dontShowCorrectAnswers'] && !$this->conf['isPoll']) {
						if (!$this->conf['dontShowPoints']) {
							$markerArray["###VAR_QUESTION_POINTS###"] = $questionPoints;
							$markerArray["###VAR_MAX_QUESTION_POINTS###"] = $maxQuestionPoints;
							$markerArray["###REF_QR_POINTS###"] = $this->cObj->substituteMarkerArray($template_qr_points, $markerArray);
						}
						
						if ( $row['explanation']!='' ) {	// Explanation
							$markerArray["###VAR_EXPLANATION###"] = $row['explanation'];
							$markerArray["###REF_QR_EXPLANATION###"] = $this->cObj->substituteMarkerArray($template_expl, $markerArray);
						}
					
						$markerArray["###REF_DELIMITER###"] = $this->cObj->substituteMarkerArray($template_delimiter, $markerArray);
					}
				}
				if (!$this->conf['dontShowCorrectAnswers'] && !$this->conf['isPoll'])	// bug fixed: points dont even matter
					$markerArrayP["###REF_QRESULT###"] .= $this->cObj->substituteMarkerArray($template_qr, $markerArray);  // instead of $content
			}
			
			$answered=substr($answered,1);	// now answered questions (UIDs)
			$doUpdate=0;					// insert or update?
			$pointsTotal=$points;			// total points, reached
			$maxTotal = $maxPoints;			// total points, maximum
			/*
			if ( !$this->conf['dontShowPoints'] && !$this->conf['isPoll'] ) {		// (vorlufige) Werte sichern
				$markerArray["###VAR_TOTAL_POINTS###"] = $pointsTotal;
				$markerArray["###VAR_TMAX_POINTS###"] = $maxTotal;
				$markerArray["###VAR_PERCENT###"] = intval(100 * $pointsTotal / $maxTotal);
			}
			*/
			if ( $this->conf['isPoll'] && !$this->conf['dontShowPollResult'] ) {
				$quizData["cmd"] = 'list';
			}
			else
			if ($this->conf['pageQuestions'] > 0 && !$this->conf['isPoll']) {	// more questions aviable?
			
				if (!$this->conf['showAnswersSeparate'])
					$quizData["cmd"] = '';						// show more/next questions!
				// Seek for old answered questions
				if ($quizData["qtuid"]) {
					$uid = intval($quizData["qtuid"]);
					$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('qids, p_or_a, p_max',
						$tableAnswers,
						'uid='.$uid.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableAnswers),
						'',
						'',
						'');
					$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
					if ($rows>0) {							// DB entry found for current user?
						$fetchedRow = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5);
						$answeredOld = $fetchedRow['qids'];
						$pointsOld = $fetchedRow['p_or_a'];
						$maxPointsOld = $fetchedRow['p_max'];
						if (stristr(','.$answeredOld.',', ','.$answered.',')) {  // somebody tries to cheat! Bug fixed: ',' matters
							$answered = $answeredOld;	// all answered questions
							$pointsTotal = $pointsOld;	// total points
							$maxTotal = $maxPointsOld;
							$doUpdate = 2;
							$markerArray["###CHEATING###"] = $this->pi_getLL('cheating','cheating');
							$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_CHEATING###");
							$markerArrayP["###REF_RES_ERRORS###"] .= $this->cObj->substituteMarkerArray($template, $markerArray);	// instead $content
						} else if ($answeredOld) {
							$answered .= ','.$answeredOld;	// all answered questions
							$pointsTotal = $points + $pointsOld;	// total points
							//$maxTotal = $maxPoints;
							if ($maxPointsOld > 0) $maxTotal = $maxTotal + $maxPointsOld;
							$doUpdate = 1;
						}
					}
				}
				$whereAnswered = ' AND uid NOT IN ('.$answered.')';	// exclude answered questions next time
			
			} else if ( $this->conf['showHighscore'] ) {
				$quizData["cmd"] = 'score';			// otherwise decide this later
			}

			if ( !$this->conf['dontShowPoints'] && !$this->conf['isPoll'] ) {	// Total points yet. && !$this->conf['dontShowCorrectAnswers'] ??
				$markerArray["###RESULT_POINTS###"] = $this->pi_getLL('result_points','result_points');
				$markerArray["###TOTAL_POINTS###"] = $this->pi_getLL('total_points','total_points');
				$markerArray["###SO_FAR_REACHED1###"] = $this->pi_getLL('so_far_reached1','so_far_reached1');
				$markerArray["###SO_FAR_REACHED2###"] = $this->pi_getLL('so_far_reached2','so_far_reached2');
				$markerArray["###VAR_RESULT_POINTS###"] = $points;
				$markerArray["###VAR_MAX_POINTS###"] = $maxPoints;
				$markerArray["###VAR_MISSING_POINTS###"] = $maxPoints - $points;
				$markerArray["###VAR_TOTAL_POINTS###"] = $pointsTotal;
				$markerArray["###VAR_TMAX_POINTS###"] = $maxTotal;
				$markerArray["###VAR_TMISSING_POINTS###"] = $maxTotal - $pointsTotal;
				if ($maxTotal>0)
					$percent = intval(round(100 * $pointsTotal / $maxTotal));
				$markerArray["###VAR_PERCENT###"] = $percent;
				$overallMaximum = $markerArray["###VAR_OMAX_POINTS###"];
				if ($overallMaximum) {
					$overallPercent = 100 * $pointsTotal / $overallMaximum;
					$markerArray["###VAR_OVERALL_PERCENT###"] = intval(round($overallPercent));
					//$markerArray["###VAR_OMAX_POINTS###"] = $overallMaximum;
				}
				
				if ($doUpdate == 0) {
					$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_RESULT_POINTS###");
				} else {
					$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_RESULT_POINTS_TOTAL###");
				}
				$markerArrayP["###REF_QPOINTS###"] = $this->cObj->substituteMarkerArray($template, $markerArray);  // instead $content
			}
			
			
			if ($points == '')
				$points = 0;
			if ($pointsTotal == '')
				$pointsTotal = 0;
				
			if ($doUpdate==0 && ($points>0 || !$this->conf['isPoll'])) {
				// get highest sorting-id
				$nextSorting = 0;
				$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('max(sorting)',
					$tableAnswers,
					'pid='.$thePID.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableAnswers),
					'',
					'',
					'');
				$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
				if ($rows>0) {
					while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5)){ 
						$nextSorting = $row['max(sorting)']+1;
					}
				}
				
				if (!$this->conf['isPoll'] && !$this->conf['dontShowPoints']) {
					$overallMaximum = $this->getTotalMax($tableQuestions, $thePID);		// maximum points of all questions
					if ($overallMaximum > 0)
						$overallPercent = 100 * $markerArray["###VAR_TOTAL_POINTS###"] / $overallMaximum;
					$markerArray["###VAR_OVERALL_PERCENT###"] = intval(round($overallPercent));
					$markerArray["###VAR_OMAX_POINTS###"] = $overallMaximum;
				}
				
				// Insert new results into database
				$timestamp = time();
				$firsttime = intval($quizData["time"]);
				$insert = array('pid' => $thePID,
								'tstamp' => $timestamp,
								'crdate' => $timestamp,
								'sorting' => $nextSorting,
								'name' => $quiz_taker_name,
								'email' => $quiz_taker_email,
								'homepage' => $quiz_taker_homepage,
								'ip' => $quiz_taker_ip_address,
								'p_or_a' => $points,
								'p_max' => $maxPoints,
								'percent' => $percent,
								'o_max' => $overallMaximum,
								'o_percent' => $overallPercent,
								'qids' => $answered,
								'firsttime' => $firsttime,
								'lasttime' => $timestamp,
								'sys_language_uid' => $this->lang);
				$success = $GLOBALS['TYPO3_DB']->exec_INSERTquery($tableAnswers, $insert);
				if($success){
					$quizData["qtuid"] = $GLOBALS['TYPO3_DB']->sql_insert_id();		
					if ( $this->conf['useCookiesInDays']>0 ) {	// save quiz takers UID as cookie?
						setcookie("myquizpoll".$thePID, $quizData["qtuid"], time()+(3600*24*$this->conf['useCookiesInDays']));  /* cookie for x days */
					}
				} else {
					$content.="<p>MySQL Insert-Error :-(</p>";
				}
			} else if ($doUpdate==1) {
				// update current user entry
				$uid=intval($quizData["qtuid"]);
				$timestamp = time();
				$update = array('tstamp' => $timestamp,
								'name' => $quiz_taker_name,
								'email' => $quiz_taker_email,
								'homepage' => $quiz_taker_homepage,
								'p_or_a' => $pointsTotal,
								'p_max' => $maxTotal,
								'percent' => $percent,
								'o_percent' => $overallPercent,
								'qids' => $answered,
								'lasttime' => $timestamp);
				$success = $GLOBALS['TYPO3_DB']->exec_UPDATEquery($tableAnswers, 'uid='.$uid.' AND sys_language_uid='.$this->lang, $update);
				if(!$success){
					$content.="<p>MySQL Update-Error :-(</p>";
				}
			}
			
			$markerArray["###QTUID###"] = $quizData["qtuid"];
			if (!$this->conf['pageQuestions'] && !$this->conf['isPoll'])
				$finalPage = true;
			$answerPage = true;
		}
		
		
		if( $this->conf['finishedMinPercent'] && $this->conf['pageQuestions']>0 && $markerArray["###VAR_TOTAL_POINTS###"]!='' &&
		  (!$this->conf['showAnswersSeparate'] || !$quizData["cmd"]) && $no_rights==0 ) {  /* ***************************************************** */
			/*
			 * Display positive cancel page: quiz taker has reached finishedMinPercent percent
			 */

			//$overallMaximum = $this->getTotalMax($tableQuestions, $thePID);		// maximum points of all questions
			$myPercent = 100 * $markerArray["###VAR_TOTAL_POINTS###"] / $markerArray["###VAR_OMAX_POINTS###"];
			$uidP = 0;
			$finishedMinPercent = $this->conf['finishedMinPercent'];
			if (strpos($finishedMinPercent, ':') !== false) {
				list($finishedMinPercent, $uidP) = split(":", $finishedMinPercent);
			}
			if (intval($finishedMinPercent) <= $myPercent) {		// do we have enough points???
				if ($uidP)		// redirect to a URL with that UID?
					header( 'Location: '.$this->pi_getPageLink($uidP) );
				$markerArray["###REACHED1###"] = $this->pi_getLL('reached1','reached1');
				$markerArray["###REACHED2###"] = $this->pi_getLL('reached2','reached2');
				$markerArray["###SO_FAR_REACHED1###"] = $this->pi_getLL('so_far_reached1','so_far_reached1');
				$markerArray["###SO_FAR_REACHED2###"] = $this->pi_getLL('so_far_reached2','so_far_reached2');
				//$markerArray["###VAR_OVERALL_PERCENT###"] = intval($myPercent);
				//$markerArray["###VAR_OMAX_POINTS###"] = $overallMaximum;
				
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_FINISHEDMINPERCENT###");
				if ($template == '')	// if it is not in the template
					$template = $this->cObj->getSubpart($this->origTemplateCode, "###TEMPLATE_QUIZ_FINISHEDMINPERCENT###");
				$content .= $this->cObj->substituteMarkerArray($template, $markerArray);			// sonderfall !!!!!!!!!
			
				$quizData["cmd"] = 'exit';		// display no more questions
			}
		}
		
		
		if( $quizData["cmd"] == '' && $no_rights==0 ) {           /* ***************************************************** */
			/*
			 * Display initial page: questions and quiz taker name fields
			 */

			// Order questions by & and limit to
			$sortBy = 'sorting';
			$limitTo = '';
			if ( $this->conf['sortBy'] ) {
				switch ($this->conf['sortBy']) {
					case "sorting": $sortBy = "sorting"; break;
					case "uid": $sortBy = "uid"; break;
					case "title": $sortBy = "title"; break;
					default: $sortBy = "sorting"; break;
				}
			}
			// Limit questions?
			if ( $this->conf['pageQuestions']>0 && $this->conf['sortBy']!='random' ) {
				$limitTo = $this->conf['pageQuestions'];
			}
			
			// Get questions from the database
			$questionsArray = array();
			$questionNumber = 0;
			$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*',
					$tableQuestions,
					'pid='.$thePID.$whereAnswered.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableQuestions),
					'',
					$sortBy,
					$limitTo);
			$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
			if ($rows>0) {
				while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5)){ 
					$questionNumber++ ;
					$questionsArray[$questionNumber] = $row;
				}
			}
			$numOfQuestions = $questionNumber;					// real questions
			$maxQuestions = $this->conf['pageQuestions'];	// should be questions
			if ($this->conf['isPoll']) {
				$maxQuestions = 1;					// only max. 1 poll-question
			} else if ( !$maxQuestions ) {
				$maxQuestions = $numOfQuestions; 
			} else if( $numOfQuestions < $maxQuestions ) { 
				$maxQuestions = $numOfQuestions; // no. of maximum question = no. of questions in the DB 
			}
		
			if ( $numOfQuestions > 0 ) {		// any questions out there???
			
				// Random questions???
				if ( $this->conf['sortBy']=='random' ) {  // || $this->conf['randomQuestions']
					$randomQuestionsArray = array();
					$questionNumber = 0;
					// Not very fast random method
					while( $questionNumber < $maxQuestions ) {
						$random = mt_rand(1,$numOfQuestions);
						$randomQuestionsArray[$questionNumber+1] = $questionsArray[$random];
						$duplicate = 0;
						for($i=1 ; $i < $questionNumber+1; $i++) {
							if( $randomQuestionsArray[$questionNumber+1]['uid'] == $randomQuestionsArray[$i]['uid'] ) {
								$duplicate = 1 ;
							}
						}
						if( !$duplicate ) { $questionNumber++ ; }
					}
					// rearange questions Array
					for( $questionNumber=1; $questionNumber < $maxQuestions+1; $questionNumber++ ) {
						$questionsArray[$questionNumber] = $randomQuestionsArray[$questionNumber];
					}
				}
			

				// Start des Output
//				$content .= "<form action=\"".$this->pi_getPageLink($GLOBALS['TSFE']->id)."\" method=\"post\" name=\"myquiz\">\n";  // old, deprecated since 0.1.8
				$lastUID = 0;      // remember the last question ID
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUESTION###");
				$template_image_begin = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUESTION_IMAGE_BEGIN###");
				$template_image_end = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUESTION_IMAGE_END###");
				$template_answer = $this->cObj->getSubpart($template, "###TEMPLATE_QUESTION_ANSWER###");
				$template_delimiter = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_DELIMITER###");
				
				if ( !$this->conf['dontShowPoints'] && !$this->conf['isPoll'] ) {
					$markerArray["###P1###"] = $this->pi_getLL('p1','p1');
					$markerArray["###P2###"] = $this->pi_getLL('p2','p2');
				} else {
					$markerArray["###P1###"] = '';
					$markerArray["###P2###"] = '';
				}
					
				// Questions and answers
				for( $questionNumber=1; $questionNumber < $maxQuestions+1; $questionNumber++) {
					$row = $questionsArray[$questionNumber];
					
					if ($row['image']) {
						$this->conf["image."]["file"] = 'uploads/tx_myquizpoll/'.($row['image']); //The image field name
						$markerArray["###VAR_QUESTION_IMAGE###"] = $this->cObj->IMAGE($this->conf["image."]);
						$markerArray["###REF_QUESTION_IMAGE_BEGIN###"] = $this->cObj->substituteMarkerArray($template_image_begin, $markerArray);
					} else {
						$markerArray["###REF_QUESTION_IMAGE_BEGIN###"] = '';
					}
					$markerArray["###VAR_QUESTION_TITLE###"] = $row['title'];
					$markerArray["###VAR_QUESTION_NAME###"] = $row['name'];
					if ( !$this->conf['dontShowPoints'] && !$this->conf['isPoll'] ) {
						$markerArray["###VAR_ANSWER_POINTS###"] = $row['points'];
					} else {
						$markerArray["###VAR_ANSWER_POINTS###"] = '';
					}
					$markerArray["###REF_QUESTION_ANSWER###"] = '';
					if ($row['qtype'] == 2) {
						$markerArray["###VAR_QUESTION_ANSWER###"] = '<select name="tx_myquizpoll_pi1[answer'.$questionNumber.']">'."\n"; //  class="'.$this->prefixId.'-answer"
					} 
					
					if (is_array($this->conf['myVars.']['questions.'])) {
						foreach($this->conf['myVars.']['questions.'] as $key => $value) {
							$myQArray = split(',', $value);
							$myKey = ($questionNumber-1)%count($myQArray);
							$markerArray["###MY_".strtoupper($key)."###"] = $myQArray[$myKey];
						}
					}
					
					// Display answers
					for( $currentValue=1; $currentValue < $this->answerChoiceMax+1; $currentValue++) {
						if( $row['answer'.$currentValue] ) {
							$answer_choice = $this->formatStr($this->local_cObj->stdWrap($row['answer'.$currentValue],$lConf["content_stdWrap."]));
							
							if (is_array($this->conf['myVars.']['answers.']) && ($row['qtype'] != 2 || $currentValue == 1)) {
								foreach($this->conf['myVars.']['answers.'] as $key => $value) {
									$myAArray = split(',', $value);
									$myKey = ($currentValue-1)%count($myAArray);
									$markerArray["###MY_".strtoupper($key)."###"] = $myAArray[$myKey];
								}
							}

							// Questtion type
							if ($row['qtype'] == 1) {
								$answer_content = '<input type="radio" name="tx_myquizpoll_pi1[answer'.$questionNumber.']" value="'.$currentValue.'" /> ';
							} else if ($row['qtype'] == 2) {
								$answer_content = '<option value="'.$currentValue.'"> ';
							} else if ($row['qtype'] == 3) {
								$answer_content = '<input type="text" name="tx_myquizpoll_pi1[answer'.$questionNumber.']" value="" /> ';
							} else {
								$answer_content = '<input type="checkbox" name="tx_myquizpoll_pi1[answer'.$questionNumber.'_'.$currentValue.']" value="'.$currentValue.'" /> ';
							}
							
							if ($row['qtype'] != 3) $answer_content .= $answer_choice;
							if ($row['qtype'] == 2) {
								$answer_content .= "</option>\n";
								$markerArray["###VAR_QUESTION_ANSWER###"] .= $answer_content;
							} else {
								$markerArray['###VAR_QUESTION_ANSWER###'] = $answer_content;
								$markerArray["###REF_QUESTION_ANSWER###"] .= $this->cObj->substituteMarkerArray($template_answer, $markerArray);
							}
														
						}
					}
					
					if ($row['qtype'] == 2) {
						$markerArray["###VAR_QUESTION_ANSWER###"] .= "</select>\n";
						$markerArray["###REF_QUESTION_ANSWER###"] .= $this->cObj->substituteMarkerArray($template_answer, $markerArray);
					}
					if ($row['image']) {
						$markerArray["###REF_QUESTION_IMAGE_END###"] = $template_image_end;
					} else {
						$markerArray["###REF_QUESTION_IMAGE_END###"] = '';
					}
					if ( (!$this->conf['dontShowUserData'] || $questionNumber<$maxQuestions) && !$this->conf['isPoll'] ) {
						$markerArray["###REF_DELIMITER###"] = $this->cObj->substituteMarkerArray($template_delimiter, $markerArray);
					} else {
						$markerArray["###REF_DELIMITER###"] = '';
					}
					
					//$this->subpart = $template;
					$template2 = $this->cObj->substituteSubpart($template, '###TEMPLATE_QUESTION_ANSWER###', $markerArray["###REF_QUESTION_ANSWER###"], 0);
					$markerArrayP["###REF_QUESTIONS###"] .= $this->cObj->substituteMarkerArray($template2, $markerArray);	// statt $content .= since 0.1.8
					$markerArrayP["###REF_QUESTIONS###"] .= '<input type="hidden" name="tx_myquizpoll_pi1[uid'.$questionNumber.']" value="'.$row['uid'].'" />';
					if ($this->conf['isPoll']) {	// link to the result page    && $this->conf['showPollResultLink']
						$urlParameters = array("tx_myquizpoll_pi1[cmd]" => "list", "tx_myquizpoll_pi1[qid]" => $row['uid'], "no_cache" => "1");
						$markerArray["###POLLRESULT_URL###"] = $this->pi_linkToPage($this->pi_getLL('poll_url','poll_url'), $GLOBALS['TSFE']->id, $target = '', $urlParameters);
					}
					$lastUID=$row['uid'];
				}
				
				// Pre-fill quiz taker name and email if FE user logged in
				if ($GLOBALS['TSFE']->loginUser) {
					if (!$quizData["name"]) { $quizData["name"] = $GLOBALS['TSFE']->fe_user->user['name']; }
					if (!$quizData["email"]) { $quizData["email"] = $GLOBALS['TSFE']->fe_user->user['email']; }
					if (!$quizData["homepage"]) { $quizData["homepage"] = $GLOBALS['TSFE']->fe_user->user['www']; }
				}
				
				if ($quizData["name"]) {
					$markerArray["###DEFAULT_NAME###"] = $quizData["name"];
				} else {
					$markerArray["###DEFAULT_NAME###"] = $this->pi_getLL('no_name','no_name');
				}
				if ($quizData["email"]) {
					$markerArray["###DEFAULT_EMAIL###"] = $quizData["email"];
				} else {
					$markerArray["###DEFAULT_EMAIL###"] = $this->pi_getLL('no_email','no_email');
				}
				if ($quizData["homepage"]) {
					$markerArray["###DEFAULT_HOMEPAGE###"] = $quizData["homepage"];
				} else {
					$markerArray["###DEFAULT_HOMEPAGE###"] = $this->pi_getLL('no_homepage','no_homepage');
				}
				
				$markerArrayP["###REF_SUBMIT_FIELDS###"] = '';
				$markerArrayP["###HIDDENFIELDS###"] = '';
				
				// User-Data Template
				if ( !$this->conf['dontShowUserData'] && !$this->conf['isPoll'] ) {
					$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_USER_TO_SUBMIT###");
					if (is_object($this->freeCap) && $this->conf['enableCaptcha']) {
						$markerArray = array_merge($markerArray, $this->freeCap->makeCaptcha());
					} else {
						$subpartArray['###CAPTCHA_INSERT###'] = '';
					}
					$markerArrayP["###REF_SUBMIT_FIELDS###"] = $this->cObj->substituteMarkerArrayCached($template,$markerArray,$subpartArray,$wrappedSubpartArray);
				} else if (!($answeredQuestions==$lastUID && $this->conf["isPoll"])) {
					$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_SUBMIT###");
					$markerArrayP["###REF_SUBMIT_FIELDS###"] = $this->cObj->substituteMarkerArray($template, $markerArray); // new in 0.1.8
					$markerArrayP["###HIDDENFIELDS###"] .= '<input type="hidden" name="name" value="'.$markerArray["###DEFAULT_NAME###"].'"> '; // statt $template .= since 0.1.8
				} else {
					$markerArray["###NO_SUBMIT###"] = $this->pi_getLL('no_submit','no_submit');
					$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_NO_SUBMIT###");
					$markerArrayP["###REF_SUBMIT_FIELDS###"] = $this->cObj->substituteMarkerArray($template, $markerArray); // new in 0.1.8
				}
				if (!$this->conf['isPoll']) {		// when is Poll, do not update result-table
					$markerArrayP["###HIDDENFIELDS###"] .= '  <input type="hidden" name="'.$this->prefixId.'[qtuid]" value="'.$quizData["qtuid"].'">';  // statt $template .= since 0.1.8
				}
				//$template .= "<input type=\"hidden\" name=\"###PREFIX###[max]\" value=\"$maxPoints\">\n";  // old, deprecated since 0.1.7
				if (!$quizData["qtuid"])
					$markerArrayP["###HIDDENFIELDS###"] .= '
  <input type="hidden" name="'.$this->prefixId.'[time]" value="'.time().'">';
				$markerArrayP["###HIDDENFIELDS###"] .= '
  <input type="hidden" name="no_cache" value="1">
  <input type="hidden" name="'.$this->prefixId.'[cmd]" value="submit">';
//  </form>';  // statt $template .= und old, deprecated since 0.1.8
				
				//$content .= $this->cObj->substituteMarkerArray($template, $markerArray);  // deprecated since long time ago
				//$content .= $this->cObj->substituteMarkerArrayCached($template,$markerArray,$subpartArray,$wrappedSubpartArray); // deprecated since 0.1.8
				$questionPage = true;			

			} else {
			
				// final page: no more questions left, if pageQuestions > 0
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_NO_MORE###");
				$markerArray["###NO_MORE###"] = $this->pi_getLL('no_more','no_more');
				$markerArray["###RESTART_QUIZ###"] = $this->pi_linkToPage($this->pi_getLL('restart_quiz','restart_quiz'), $GLOBALS['TSFE']->id, $target = '', array());
				$questions = '';
				
				if ($this->conf['showAllCorrectAnswers'] && !$this->conf['isPoll']) {		// show all answers...
				
					$template_entry = $this->cObj->getSubpart($template, "###QUIZ_ANSWERS###");
					$template_answer = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QR_CORR###");
					$template_expl = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_EXPLANATION###");
					$template_delimiter = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_DELIMITER###");

					$markerArrayS = array();
					$markerArrayS["###PREFIX###"] = $this->prefixId;
					if ( !$this->conf['dontShowPoints'] ) {
						$markerArrayS["###P1###"] = $this->pi_getLL('p1','p1');
						$markerArrayS["###P2###"] = $this->pi_getLL('p2','p2');
					} else {
						$markerArrayS["###P1###"] = '';
						$markerArrayS["###P2###"] = '';
					}

					$sortBy = 'sorting';
					if ( $this->conf['sortBy'] ) {
						switch ($this->conf['sortBy']) {
							case "sorting": $sortBy = "sorting"; break;
							case "uid": $sortBy = "uid"; break;
							case "title": $sortBy = "title"; break;
							default: $sortBy = "sorting"; break;
						}
					}
					
					// Get all questions and answers from the database
					$questionsArray = array();
					$questionNumber = 0;
					$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('*',
							$tableQuestions,
							'pid='.$thePID.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableQuestions),
							'',
							$sortBy,
							'');
					$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
					if ($rows>0) {
						while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5)){ 
							$questionNumber++;
							$markerArrayS["###VAR_QUESTION_TITLE###"] = $row['title'];
							$markerArrayS["###VAR_QUESTION_NAME###"] = $row['name'];
							if ( !$this->conf['dontShowPoints'] ) {
								$markerArrayS["###VAR_ANSWER_POINTS###"] = $row['points'];
							} else {
								$markerArrayS["###VAR_ANSWER_POINTS###"] = '';
							}
							$markerArrayS["###REF_QR_ANSWER_CORR###"] = '';
							$markerArrayS["###REF_QR_EXPLANATION###"] = '';
							if ($questionNumber < $rows) {
								$markerArrayS["###REF_DELIMITER###"] = $this->cObj->substituteMarkerArray($template_delimiter, $markerArrayS);
							} else {
								$markerArrayS["###REF_DELIMITER###"] = '';
							}
							
							if ( $row['explanation']!='' ) {	// Explanation
								$markerArrayS["###VAR_EXPLANATION###"] = $row['explanation'];
								$markerArrayS["###REF_QR_EXPLANATION###"] = $this->cObj->substituteMarkerArray($template_expl, $markerArrayS);
							}
						
							for( $answerNumber=1; $answerNumber < $this->answerChoiceMax+1; $answerNumber++ ) {
								if ($row['answer'.$answerNumber]) {	// was a answer set in the backend?		
									if ($row['correct'.$answerNumber] || $row['qtype']==3) { // all correct answers
										$markerArrayS["###VAR_QUESTION_ANSWER###"] = $row['answer'.$answerNumber];
										$markerArrayS["###REF_QR_ANSWER_CORR###"] .= $this->cObj->substituteMarkerArray($template_answer, $markerArrayS);
									}
								}
							}

							$questions .= $this->cObj->substituteMarkerArray($template_entry, $markerArrayS);
						}
					}
					$GLOBALS['TYPO3_DB']->sql_free_result($res5); 

				}
				
				$subpart = $template;
				$template = $this->cObj->substituteSubpart($subpart, '###QUIZ_ANSWERS###', $questions, 0);
				$markerArrayP["###REF_NO_MORE###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
				
				if ( $this->conf['showHighscore'] ) {
					$quizData["cmd"] = 'score';
				}
				$finalPage = true;

			}
			
		} else if ($this->conf['showAnswersSeparate'] && $quizData["cmd"]=='submit' && !$this->conf['isPoll'] && $no_rights==0) { /* ***************************************************** */
			/*
			 * Display only a next button
			 */
			 
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_NEXT###");
			if ($template == '')	// if it is not in the template
				$template = $this->cObj->getSubpart($this->origTemplateCode, "###TEMPLATE_NEXT###");
			$markerArrayP["###REF_NEXT###"] = $this->cObj->substituteMarkerArray($template, $markerArray);	// instead $content
		}

		
		if ( $quizData["cmd"] == 'score' && !$this->conf['isPoll'] ) {         /* ***************************************************** */
			/*
			 * Display highscore page: top 10 table
			 */
			if ($finalPage)
				$markerArrayP["###REF_HIGHSCORE###"] = $this->showHighscoreList($quizData, $thePID, $tableQuestions, $tableAnswers);
			else
				$content .= $this->showHighscoreList($quizData, $thePID, $tableQuestions, $tableAnswers);
			
			
		} else if ( $quizData["cmd"] == 'list' && $this->conf['isPoll'] ) {     /* ***************************************************** */
			/*
			 * Display poll result
			 */
			if ($answerPage)
				$markerArrayP["###REF_POLLRESULT###"] = $this->showPollResult($answered, $quizData, $thePID, $tableQuestions, $tableAnswers);
			else
				$content .= $this->showPollResult($answered, $quizData, $thePID, $tableQuestions, $tableAnswers);
			
		} 
		
		
		if ( !$this->conf['dontShowHighscoreLink'] && !$this->conf['isPoll'] && $quizData["cmd"]!='score' ) {	// show highscore link?
  			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_HIGHSCORE_URL###");
			//if ($questionPage || $answerPage || $finalPage)
				$markerArrayP["###REF_HIGHSCORE_URL###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
			//else
			//	$content .= $this->cObj->substituteMarkerArray($template, $markerArray);
  		}
		
		if ( $this->conf['isPoll'] && $quizData["cmd"]!='list' ) {	// show poll result link? && $this->conf['showPollResultLink']
  			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_POLLRESULT_URL###");
  			//if ($questionPage || $answerPage)
				$markerArrayP["###REF_POLLRESULT_URL###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
			//else
			//	$content .= $this->cObj->substituteMarkerArray($template, $markerArray);
  		}

		
		/** Layout for a result page **/
		if ($answerPage && $quizData["cmd"] != 'exit') {
			if ( $this->conf['quizTimeMinutes'] ) {
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_TIME_LIMIT###");
				if (!$quizData["qtuid"]) {
					$markerArray["###VAR_SECS###"] = intval($this->conf['quizTimeMinutes'])*60;
					$markerArray["###VAR_MIN###"] = $this->conf['quizTimeMinutes'];
				} else {
					$markerArray["###VAR_SECS###"] = intval($this->conf['quizTimeMinutes'])*60 - $elapseTime;
					$markerArray["###VAR_MIN###"] = round($markerArray["###VAR_SECS###"]/60);				
				}
				$markerArrayP["###REF_QUIZ_LIMIT###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
			} else {
				$markerArrayP["###REF_QUIZ_LIMIT###"] = '';
			}
			
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_RESULT_PAGE###");
			if ($template == '')	// if it is not in the (old custom) template
				$template = $this->cObj->getSubpart($this->origTemplateCode, "###TEMPLATE_RESULT_PAGE###");
			$content .= $this->cObj->substituteMarkerArray($template, $markerArrayP);
		}

		
		/** Layout for a questions page **/
		if ($questionPage && $quizData["cmd"] != 'exit') {
			if ( $this->conf['pageTimeSeconds'] ) {
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_PAGE_TIME_LIMIT###");
				$markerArray["###VAR_SECS###"] = $this->conf['pageTimeSeconds'];
				$markerArrayP["###REF_PAGE_LIMIT###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
			} else {
				$markerArrayP["###REF_PAGE_LIMIT###"] = '';
			}
			
			if ( $this->conf['quizTimeMinutes'] ) {
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_TIME_LIMIT###");
				if (!$quizData["qtuid"]) {
					$markerArray["###VAR_SECS###"] = intval($this->conf['quizTimeMinutes'])*60;
					$markerArray["###VAR_MIN###"] = $this->conf['quizTimeMinutes'];
				} else {
					$markerArray["###VAR_SECS###"] = intval($this->conf['quizTimeMinutes'])*60 - $elapseTime;
					$markerArray["###VAR_MIN###"] = round($markerArray["###VAR_SECS###"]/60);				
				}
				$markerArrayP["###REF_QUIZ_LIMIT###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
//				$markerArrayP["###HIDDENFIELDS###"] .= '
//  <input type="hidden" name="'.$this->prefixId.'[cancel]" value="0">';
			} else {
				$markerArrayP["###REF_QUIZ_LIMIT###"] = '';
			}
			
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUESTION_PAGE###");
			if ($template == '')	// if it is not in the template
				$template = $this->cObj->getSubpart($this->origTemplateCode, "###TEMPLATE_QUESTION_PAGE###");
			$content .= $this->cObj->substituteMarkerArray($template, $markerArrayP);
		}
		
		
		/** Layout for the last/final page **/
		if ($finalPage && $quizData["cmd"] != 'exit' && !$this->conf['isPoll']) {
			if ($this->conf['showAnalysis'] && !$this->conf['dontShowPoints'] && $markerArray["###VAR_TMAX_POINTS###"]) {	// Analysis depends on points
				$percent = 100 * $markerArray["###VAR_TOTAL_POINTS###"] / $markerArray["###VAR_TMAX_POINTS###"];	// genauerer wert...
				$markerArray["###VAR_PERCENT###"] = intval($percent);
				$markerArray["###REACHED1###"] = $this->pi_getLL('reached1','reached1');
				$markerArray["###REACHED2###"] = $this->pi_getLL('reached2','reached2');
				$percentsArray = split(',', $this->conf['showAnalysis']);
				$percentTemplateNo = '';
				$p = 0;
				$uidP = 0;
				while ($p < count($percentsArray)) {
					$percentTemplateNo = $percentsArray[$p];
					if (strpos($percentTemplateNo, ':') !== false) {
						list($percentTemplateNo, $uidP) = split(":", $percentTemplateNo);
					}
					if ($percent <= floatval($percentTemplateNo)) {
						if ($uidP)		// redirect to a URL with that UID
							header( 'Location: '.$this->pi_getPageLink($uidP) );
						break;
					}
					$p++;
				}
				$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_ANALYSIS_$percentTemplateNo###");
				$markerArrayP["###REF_QUIZ_ANALYSIS###"] = $this->cObj->substituteMarkerArray($template, $markerArray);
			}
			
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_QUIZ_FINAL_PAGE###");
			if ($template == '')	// if it is not in the template
				$template = $this->cObj->getSubpart($this->origTemplateCode, "###TEMPLATE_QUIZ_FINAL_PAGE###");
			$content .= $this->cObj->substituteMarkerArray($template, $markerArrayP);
		}
		
		
		return $this->pi_wrapInBaseClass($content);
	}
	
	
	
	// show highscore list
	function showHighscoreList($quizData, $thePID, $tableQuestions, $tableAnswers) {
	
			$nr=0;
			$limit='';
			$date_format='m-d-Y';
			if ( $this->conf['dateFormat'] ) { $date_format=$this->conf['dateFormat']; } // date format
			
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_HIGHSCORE###");
			$template_entry = $this->cObj->getSubpart($template, "###TEMPLATE_HIGHSCORE_ENTRY###");
			$template_caption = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_HIGHSCORE_CAPTION###");
			$template_quiz_taker = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_HIGHSCORE_QUIZ_TAKER###");
			
			$markerArray=array();
			$markerArrayH=array();
			$markerArrayS=array();
			$markerArray["###PREFIX###"] = $this->prefixId;
			$markerArray["###REF_HIGHSCORE_CAPTION###"] = '';
			$markerArray["###REF_HIGHSCORE_ENTRY###"] = '';
			
			if ( $this->conf['highscoreEntries']>0 ) {
				$markerArray["###HIGHSCORE_CAPTION###"] = $this->pi_getLL('highscore_caption','highscore_caption');
				$markerArray["###VAR_HIGHSCORE_LIMIT###"] = $this->conf['highscoreEntries'];
				$markerArray["###REF_HIGHSCORE_CAPTION###"] = $this->cObj->substituteMarkerArray($template_caption, $markerArray);
				$limit = $this->conf['highscoreEntries'];
			}
			
			$markerArray["###NUMBER###"] = $this->pi_getLL('number','number');
			$markerArray["###POINTS###"] = $this->pi_getLL('points','points');
			$markerArray["###PERCENT###"] = $this->pi_getLL('percent','percent');
			$markerArray["###TIME###"] = $this->pi_getLL('time','time');
			$markerArray["###NAME###"] = $this->pi_getLL('name','name');
			$markerArray["###DATE###"] = $this->pi_getLL('date','date');
			
			if ( $this->conf['sortHighscoreBy']=='percent' ) {
				$orderBy='percent DESC';
			} else if ( $this->conf['sortHighscoreBy']=='o_percent' ) {
				$orderBy='o_percent DESC';
			} else if ( $this->conf['sortHighscoreBy']=='time' ) {
				$orderBy='(lasttime-firsttime) ASC';
			} else {
				$orderBy='p_or_a DESC';
			}
			
			$res4 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('uid,p_or_a,p_max,percent,o_max,o_percent,lasttime,firsttime,name,email,homepage,tstamp',
					$tableAnswers,
					'pid='.$thePID.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableAnswers),
					'',
					$orderBy.', sorting DESC',
					$limit);
			$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res4);
			if ($rows>0) {
				while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res4)){
					$aDate = date($date_format, $row['tstamp']);
					$aTime = mktime(0, 0, 0, 1, 1, 2009);
					$aTime += intval($row['lasttime'])-intval($row['firsttime']); // - 60*60;	// - 1 Stunde, warum auch immer das noetig ist...
					$aTime = date('G:i:s', $aTime);
					
					if ($row['uid'] == $quizData["qtuid"]) {		// aktueller eintrag
						$markerArrayS["###EVEN_ODD###"] = $markerArrayS["###MY_EVEN_ODD###"] = '-act';
					} else {
						if (is_array($this->conf['myVars.']['list.'])) {
							foreach($this->conf['myVars.']['list.'] as $key => $value) {
								$myQArray = split(',', $value);
								$myKey = ($nr)%count($myQArray);
								$markerArrayS["###MY_".strtoupper($key)."###"] = $myQArray[$myKey];
							}
						} else {		// aus kompatibilitaetsgruenden
							if (($nr % 2) == 0) {
								$markerArrayS["###EVEN_ODD###"] = ' tr-even';
							} else {
								$markerArrayS["###EVEN_ODD###"] = ' tr-odd';
							}
						}
					}
					
					$markerArrayH["###VAR_NAME###"] = $row['name'];
					$markerArrayH["###VAR_EMAIL###"] = $row['email'];
					$markerArrayH["###VAR_HOMEPAGE###"] = $row['homepage'];
					if ($row['homepage'] != "" && $row['homepage'] != $this->pi_getLL('no_homepage','no_homepage')) {
						$url_http=$row['homepage'];
						if (substr($url_http, 0,4) != 'http')
							$url_http='http://'.$url_http;
						$markerArrayH["###VAR_TO_HOMEPAGE###"] = "<a href=\"".$url_http."\" target=\"hp\">-&gt; ".$this->pi_getLL('homepage','homepage')."</a><br/>";
					} else {
						$markerArrayH["###VAR_TO_HOMEPAGE###"] = '';
					}
					$markerArrayH["###VAR_NAME_AND_EMAIL###"] = $row['name']."<br/>\n";
					if ($row['email'] != "" && $row['email'] != $this->pi_getLL('no_email','no_email')) {
						$email_crypt = $GLOBALS['TSFE']->encryptEmail('mailto:'.$row['email']); 
						if ($email_crypt == 'mailto:'.$row['email']) {		// Bug fixed: not always linkTo_UnCryptMailto
							$nameandemail = $email_crypt;
						} else {
							$nameandemail = "javascript:linkTo_UnCryptMailto('".$email_crypt."')";
						}
						$markerArrayH["###VAR_NAME_AND_EMAIL###"] = '<a href="'.$nameandemail.'">'.$row['name']."</a><br/>\n";
					}
					$markerArrayS["###REF_HIGHSCORE_QUIZ_TAKER###"] = $this->cObj->substituteMarkerArray($template_quiz_taker, $markerArrayH);
					
					$markerArrayS["###VAR_COUNT###"] = $nr+1;
					$markerArrayS["###VAR_POINTS###"] = $row['p_or_a'];
					$markerArrayS["###VAR_MAX###"] = $row['p_max'];
					$markerArrayS["###VAR_O_MAX###"] = $row['o_max'];
					$markerArrayS["###VAR_PERCENT###"] = $row['percent'];
					$markerArrayS["###VAR_O_PERCENT###"] = $row['o_percent'];
					$markerArrayS["###VAR_TIME###"] = $aTime;
					$markerArrayS["###VAR_DATE###"] = $aDate;
					$markerArray["###REF_HIGHSCORE_ENTRY###"] .= $this->cObj->substituteMarkerArray($template_entry, $markerArrayS);
					
					$nr++;
				}
			}
			$GLOBALS['TYPO3_DB']->sql_free_result($res4); 
			$subpart = $template;
			$template = $this->cObj->substituteSubpart($subpart, '###TEMPLATE_HIGHSCORE_ENTRY###', $markerArray["###REF_HIGHSCORE_ENTRY###"], 0);
			$out = $this->cObj->substituteMarkerArray($template, $markerArray);
			return $out;
			
	}
	
	
	// show poll result
	function showPollResult($answered, $quizData, $thePID, $tableQuestions, $tableAnswers) {
	
			// poll answers
			$votes=0;
			$hits=0;
			$percent=0;

			if (!$answered) {	// link clicked?
				$answered = $quizData["qid"];
			}
			if ($answered) {
				$answeredP = ' AND uid='.$answered;
				$answeredQ = ' AND qids='.$answered;
			}
			
			$template = $this->cObj->getSubpart($this->templateCode, "###TEMPLATE_POLLRESULT###");
			$template_entry = $this->cObj->getSubpart($template, "###TEMPLATE_POLLRESULT_ENTRY###");
			
			$markerArray=array();
			$markerArrayS=array();
			$markerArray["###PREFIX###"] = $this->prefixId;
			$markerArray["###REF_POLLRESULT_ENTRY###"] = '';
			$markerArray["###ANSWER###"] = $this->pi_getLL('answer','answer');
			$markerArray["###VOTES###"] = $this->pi_getLL('votes','votes');
			
			// poll question
			$query = 'SELECT * FROM '.$tableQuestions.' WHERE pid='.$thePID.$answeredP.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableQuestions);
			$queryResult = mysql( TYPO3_db, $query );
			echo mysql_error();
			$row = mysql_fetch_assoc($queryResult);
			
			$markerArray["###VAR_QUESTION_TITLE###"] = $row['title'];
			$markerArray["###VAR_QUESTION_NAME###"] = $row['name'];
			
			// votes
			$res2 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('count(p_or_a), p_or_a',
					$tableAnswers,
					'pid='.$thePID.$answeredQ.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableAnswers),
					'p_or_a',
					'p_or_a',
					'');
			$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res2);
			if ($rows>0) {
				while($row2 = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res2)){
					$aAnswer=$row2['p_or_a'];
					if ($aAnswer) {		// since 0.2.1
						$row['votes'.$aAnswer]=$row2['count(p_or_a)'];	// Votes for a answer
						$votes+=$row2['count(p_or_a)'];
					}
				}
			}
			
			// show the answers and votes
			for ($nr=1; $nr<=$this->answerChoiceMax; $nr++) {
			  if ($row['answer'.$nr]) {
				if (is_array($this->conf['myVars.']['list.'])) {
					foreach($this->conf['myVars.']['list.'] as $key => $value) {
						$myQArray = split(',', $value);
						$myKey = ($nr-1)%count($myQArray);
						$markerArrayS["###MY_".strtoupper($key)."###"] = $myQArray[$myKey];
					}
				} else {
					$markerArrayS["###EVEN_ODD###"] = (($nr % 2) == 0) ? ' tr-even' : ' tr-odd';
				}
						
				$markerArrayS["###VAR_ANSWER###"] = $row['answer'.$nr];
				if ($row['votes'.$nr]) {
					$hits=$row['votes'.$nr];
					$percent=round(100*$row['votes'.$nr]/$votes, 2);
				} else {
					$hits=0;
					$percent=0;
				}
				$markerArrayS["###VAR_HITS###"] = $hits;
				$markerArrayS["###VAR_PERCENT###"] = $percent;
				$markerArray["###REF_POLLRESULT_ENTRY###"] .= $this->cObj->substituteMarkerArray($template_entry, $markerArrayS);
				$markerArray["###VAR_ANSWER$nr###"] = $markerArrayS["###VAR_ANSWER###"];
				$markerArray["###VAR_HITS$nr###"] = $markerArrayS["###VAR_HITS###"];
				$markerArray["###VAR_PERCENT$nr###"] = $markerArrayS["###VAR_PERCENT###"];
			  }
			}
			$markerArray["###VAR_VOTES###"] = $votes;
			$this->subpart = $template;
			$template = $this->cObj->substituteSubpart($this->subpart, '###TEMPLATE_POLLRESULT_ENTRY###', $markerArray["###REF_POLLRESULT_ENTRY###"], 0);
			$out = $this->cObj->substituteMarkerArray($template, $markerArray);
			mysql_free_result($queryResult);
			return $out;
			
	}
	
	
	/**
	 * Format string with nl2br and htmlspecialchars()
	 */
	function formatStr($str)	{
		if (is_array($this->conf["general_stdWrap."]))	{
			$str = $this->local_cObj->stdWrap($str,$this->conf["general_stdWrap."]);
		}
		return $str;
	}
	
	
	/**
    * read the template file, fill in global wraps and markers and write the result
    * to '$this->templateCode'
    *
    * @return    void
    */
	function initTemplate() {
       // read template-file and fill and substitute the Global Markers
       $templateFile = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'template_file', 's_template');
       $origTemplateFile = 'EXT:myquizpoll/pi1/tx_myquizpoll_pi1.tmpl';	
	   if ($templateFile) {
           if (false === strpos($templateFile, '/')) {
               $templateFile = 'uploads/tx_myquizpoll/' . $templateFile;
           }
       } else if ($this->conf['templateFile']) {
           $templateFile = $this->conf['templateFile'];
       } else {
	   	   $templateFile = $origTemplateFile;		  
       }
	   $this->templateCode = $this->cObj->fileResource($templateFile);
	   $this->origTemplateCode = $this->cObj->fileResource($origTemplateFile);
   } 

   
   /**
    * Calculate the total maximum points of all questions of a quiz
    *
    * @return    $max		Total maximum points of all questions of a quiz
    */
	function getTotalMax($tableQuestions, $pid) {
		$maxPoints = 0;
		
		// Get all questions from the database
		$questionsArray = array();
		$questionNumber = 0;
		$res5 = $GLOBALS['TYPO3_DB']->exec_SELECTquery('qtype,answer1,answer2,answer3,answer4,answer5,correct1,correct2,correct3,correct4,correct5,points',
				$tableQuestions,
				'pid='.$pid.' AND sys_language_uid='.$this->lang.' '.$this->cObj->enableFields($tableQuestions),
				'',
				'',
				'');
		$rows = $GLOBALS['TYPO3_DB']->sql_num_rows($res5);
		if ($rows>0) {
			while($row = $GLOBALS['TYPO3_DB']->sql_fetch_assoc($res5)){ 
				for( $answerNumber=1; $answerNumber < $this->answerChoiceMax+1; $answerNumber++ ) {	
					if ($row['answer'.$answerNumber]) {	// was a answer set in the backend?
						if ($row['correct'.$answerNumber] || $row['qtype']==3) {
							$maxPoints=$maxPoints+$row['points'];
						}
					}
				}
			}
		}
		$GLOBALS['TYPO3_DB']->sql_free_result($res5); 
		
		return $maxPoints;
    }
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/myquizpoll/pi1/class.tx_myquizpoll_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/myquizpoll/pi1/class.tx_myquizpoll_pi1.php']);
}

?>